<!DOCTYPE node PUBLIC
'-//freedesktop//DTD D-BUS Object Introspection 1.0//EN'
'http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd'>
<node>

  <!--
      org.apertis.Rhosydd1.Vehicle:
      @short_description: exposes a collection of vehicles on the bus.

       This will expose all the necessary objects on the bus for peers
       to interact with them, and hooks them up to internal state management
       using #CsrVehicleService:vehicle-manager.
   -->
  <interface name="org.apertis.Rhosydd1.Vehicle">

    <!--
        VehicleId: the identification string for the vehicle.
    -->
    <property name="VehicleId" type="s" access="read" />

    <!--
        GetAttributes:
        @node_path: the node path to the branch or leaf node.
                    Pass empty path "" to get all the 
                    attributes of the vehicle.
        @current_time: current timestamp.
        @attributes: array of all attributes with value and metadata.

        Get values and metadata of all attributes in branch node @node_path.   
        Send empty node_path "" to get all attributes in the vehicle
        irrespective of the branch. 
    -->
    <method name="GetAttributes">
      <arg type="s" name="node_path" direction="in" />
      <arg type="x" name="current_time" direction="out" />
      <arg type="a(s(vdx)a{sv}(uu))" name="attributes" direction="out" />
    </method>

    <!--
        GetAttributesMetadata:
        @node_path: the node path as a string.
        @current_time: current timestamp.
        @attributes_metadata: array of metadata for all attributes.

        Get metadata for all attributes in node @node_path.
    -->
    <method name="GetAttributesMetadata">
      <arg type="s" name="node_path" direction="in" />
      <arg type="x" name="current_time" direction="out" />
      <arg type="a(sa{sv}(uu))" name="attributes_metadata" direction="out" />
    </method>

    <!--
        SetAttributes
        @attributes_value: the name of the attribute to be set.
    -->
    <method name="SetAttributes">
      <arg type="a{sv}" name="attributes_value" direction="in" />
    </method>

    <!--
        UpdateSubscriptions:
        @subscriptions: array of subscriptions to be registered.
        @unsubscriptions: array of subscriptions to be removed.

        Update subscriptions to the service.
    -->
    <method name="UpdateSubscriptions">
      <arg type="a(sa{sv})" name="subscriptions" direction="in" />
      <arg type="a(sa{sv})" name="unsubscriptions" direction="in" />
    </method>

    <!--
        AttributesChanged:
        @current_time: current timestamp.
        @changed_attributes: array with attributes that changed and their values and metadata.
        @invalidated_attributes: array of attributes that were invalidated with their metadata.
    -->
    <signal name="AttributesChanged">
      <arg type="x" name="current_time" />
      <arg type="a(s(vdx)a{sv}(uu))" name="changed_attributes" />
      <arg type="a(sa{sv}(uu))" name="invalidated_attributes" />
    </signal>

    <!--
        AttributesMetadataChanged:
        @current_time: current timestamp.
        @changed_attributes: array with attributes that changed and their values and metadata.
        @invalidated_attributes: array of attributes that were invalidated with their metadata.
    -->
    <signal name="AttributesMetadataChanged">
      <arg type="x" name="current_time" />
      <arg type="a(sa{sv}(uu))" name="changed_attributes_metadata" />
    </signal>

  </interface>

</node>
